import os, md5, time, pickle, random
from helpers import *
try:
    import crypt
except:
    pass

################### CONSTANTS ####################

# For the script to work, you must uncomment the following lines.
# Be sure to set BASE_URL to your website.
# BASE_URL = 'http://example.com/'
# LOGIN_CGI = 'login.cgi'
# NEWUSER_CGI = 'newuser.cgi'
# FORGOT_CGI = 'forgot.cgi'
# welcome_text = ''
# get_header()
# get_footer()
# SESSION_DIR = 'sessions/'
# AUTHFILE    = 'users/auth'
# LOGIN       = 'login'
# PASSWD      = 'passwd'
# PASSWD2     = 'passwd2'
# EMAIL       = 'email'
# DESTINATION = 'destination'
# DEFAULT_DEST= INPUT_SURVEY_CGI

############### AUTHENTICATION HELPERS #############

def generate_password():
    return random.randrange(10000, 100000)

def get_salt(user, password):
    '''Return a 2-character salt for the 'crypt'
       algorithm, either the salt used previously
       for the specified user or a randomly-generated
       one.
    '''
    if get(user, PASSWD):
        return get(user, PASSWD)[:2]
    return hex(random.randrange(10000, 100000))[-2:]

def encrypt(user, password, crypt_type=DEFAULT_ENCRYPTION):
    if crypt_type == MD5:
        return get_md5(user, password)
    if crypt_type == CRYPT:
        return crypt.crypt(password, get_salt(user, password))

def get_md5(user, password):
    return md5.new(user + password).hexdigest()

def get_userdict():
    try:
        file = open(AUTHFILE)
        dict = pickle.load(file)
        file.close()
    except(IOError):
        dict = {}
    return dict

def get_owner(survey_id):
    '''Return the owner of the survey_id if there is one,
       or an empty string otherwise.
    '''
    dict = get_userdict()
    for username in dict:
        if survey_id in dict[username].get(SURVEYS, []):
            return username
    return ''

def save_userdict(dict):
    listdir(USERS_DIR)
    file = open(AUTHFILE, 'w')
    pickle.dump(dict, file)
    file.close()

def get(user, attribute):
    '''Return attribute if it's stored, otherwise
       an emptry string.
    '''
    att = ''
    if attribute == SURVEYS:
        att = []
    users = get_userdict()
    if user and user in users:
        att = users[user].get(attribute, att)
    return att

def set(user, attribute, value):
    users = get_userdict()
    if user not in users:
        users[user] = {}
    if attribute == SURVEYS:
        existing_surveys = users[user].get(SURVEYS, [])
        if value not in existing_surveys:
            existing_surveys.append(value)
        value = existing_surveys
    users[user][attribute] = value
    save_userdict(users)

def delete(user, attribute, value=''):
    users = get_userdict()
    if user in users:
        if attribute == SURVEYS:
            existing_surveys = users[user].get(SURVEYS, [])
            if value in existing_surveys:
                existing_surveys.remove(value)
            users[user][SURVEYS] = existing_surveys
        else:
            del users[user][attribute]
        save_userdict(users)

def _password_error(pass1, pass2):
    errors = []
    try:
        if not pass1.isalnum():
            errors.append('Please enter only letters and numbers for your password.')
        if len(pass1) < 4:
            errors.append('For security, please make your password at least 4 characters long.')
        if not pass1 == pass2:
            errors.append('Your passwords didn\'t match. Please enter them again.')
    except:
        errors.append('Please enter your password again.')
    return errors

################ SESSION FUNCTIONS ################

def get_session():
    session = os.environ.get('PATH_INFO', '')
    return session

def make_session(username):
    """Return a new session key, also adding it to the session database
       (with username and expiration time).
    """
    remove_sessions()
    from random import randrange
    expiry = int(time.time()) + 60
    key = '/%x' % randrange(1, 1000000, 1)
    while key in listdir(SESSION_DIR):
        key = '/%x' % randrange(1, 1000000, 1)
    file = open('%s%s' % (SESSION_DIR, key), 'w')
    file.write('%s, %s' % (username, expiry))
    file.close()
    return key

def check_session(key):
    """Return the session's username if the given session is in the
       database and not expired, an empty string otherwise.
    """
    key = key.lstrip('/')
    user = ''
    if key.lstrip('/') in listdir(SESSION_DIR):
        file = open('%s/%s' % (SESSION_DIR, key))
        (username, expiry) = file.read().split(', ')
        file.close()
        current = int(time.time())
        if 1: #current <= int(expiry): TODO
            user = username
        else:
            remove_sessions(key)
            # os.remove('%s/%s' % (SESSION_DIR, key))
    return user

def remove_sessions(key=''):
    """If a key is given, remove that key from the database if
         it exists and remove expired sessions from the session database.
         Else, just remove expired sessions.
    """
    key = key.lstrip('/')
    if key and key in listdir(SESSION_DIR):
        os.remove('%s/%s' % (SESSION_DIR, key))
        print 'here'

    current = int(time.time())
    for key in listdir(SESSION_DIR):
        file = open('%s/%s' % (SESSION_DIR, key))
        expiry = int(file.read().split(', ')[1])
        file.close()
        if current > expiry:
            os.remove('%s/%s' % (SESSION_DIR, key))

################### FORMS ####################

def login_form(dict={}, errors=[]):
    form = '<div class="error">' + '<br>'.join(errors) + '''</div>
        <form action="'''+LOGIN_CGI+'''" method="post">
        <table>
        <tr>
          <td colspan="2" class="title">Login</td>
        </tr>
        <tr>
          <td align="right">Username:</td>
          <td><input type="text" name="'''+LOGIN+'" value="'+dict.get(LOGIN, '')+'''"></td>
        </tr>
        <tr>
          <td align="right">Password:</td>
          <td><input type="password" name="'''+PASSWD+'''"></td>
        </tr>
        <tr>
          <td></td>
          <td><input type="submit" value="Login"></td>
        </tr>
        </table>'''
    for key in dict.keys():
        if key not in SAVED_KEYS:
            form += '<input type="hidden" name="' + key + \
                    '" value="' + dict[key] + '">\n'
    form += '</form>'
    return form

def newuser_form(dict={}, errors=[]):
    if not ALLOW_NEWUSERS:
        return ''
    form = '<div class="error">' + '<br>'.join(errors) + '''</div>
        <form action="'''+NEWUSER_CGI+'''" method="post">
        <table>
        <tr>
          <td colspan="2" class="title">Make Account</td>
        </tr>
        <tr>
          <td align="right">Username:</td>
          <td><input type="text" name="'''+LOGIN+'" value="'+dict.get(LOGIN, '')+'''"></td>
        </tr>
        <tr>
          <td align="right">Password:</td>
          <td><input type="password" name="'''+PASSWD+'''"></td>
        </tr>
        <tr>
          <td align="right">Retype:</td>
          <td><input type="password" name="'''+PASSWD2+'''"></td>
        </tr>
        <tr>
          <td align="right">Email:</td>
          <td><input type="text" name="'''+EMAIL+'''" value="''' + dict.get(EMAIL, '') + '''"></td>
        </tr>
        <tr>
          <td></td>
          <td><input type="submit" value="Make Account"><br></td>
        </tr>
        </table>'''
    for key in dict.keys():
        if key not in SAVED_KEYS:
            form += '<input type="hidden" name="' + key + \
                    '" value="' + dict[key] + '">\n'
    form += '</form>'
    return form

def forgot_form(dict={}, errors=[]):
    if not SHOW_FORGOTPASSWORD:
        return ''
    form = '<div class="error">' + '<br>'.join(errors) + '''</div>
        <form action="''' + CHANGE_USERINFO_CGI + '''" method="post">
        <input type="hidden" name="'''+DESTINATION+'" value="'+RESET+'''">
        <table>
        <tr>
          <td class="title">Forgot Password</td>
        </tr>
        <tr>
          <td>
            Enter your username below, and your password
            will be reset and sent to the email address that
            is on file for you.  You are encouraged to change
            this password as soon as you log in again.
          </td>
        </tr>
        </table>
        <table>
        <tr>
          <td align="right">Username:</td>
          <td><input type="text" name="'''+LOGIN+'" value="'+dict.get(LOGIN, '')+'''"></td>
          <td></td>
        </tr>
        <tr>
          <td></td>
          <td><input type="submit" value="Reset Password"></td>
          <td></td>
        </tr>
        </table>'''
    for key in dict.keys():
        if key not in SAVED_KEYS:
            form += '<input type="hidden" name="' + key + \
                    '" value="' + dict[key] + '">\n'
    form += '</form>'
    return form

def change_password_form(dict={}, errors=[]):
    form = '<div class="error">' + '<br>'.join(errors) + '''</div>
        <form action="''' + CHANGE_USERINFO_CGI + get_session() + '''" method="post">
        <input type="hidden" name="'''+DESTINATION+'" value="'+PASSWORD+'''">
        <table>
        <tr>
          <td colspan="2" class="title">Change Password</td>
        </tr>
        <tr>
          <td align="right">New password:</td>
          <td><input type="password" name="'''+PASSWORD+'" value="'+dict.get(PASSWORD, '')+'''"></td>
        </tr>
        <tr>
          <td align="right">Retype:</td>
          <td><input type="password" name="'''+PASSWORD+'2'+'" value="'+dict.get(PASSWORD+'2', '')+'''"></td>
        </tr>
        <tr>
          <td></td>
          <td><input type="submit" value="Change Password"></td>
        </tr>
        </table>'''
    for key in dict.keys():
        if key not in SAVED_KEYS:
            form += '<input type="hidden" name="' + key + \
                    '" value="' + dict[key] + '">\n'
    form += '</form>'
    return form

def change_email_form(dict={}, errors=[]):
    current_email = get(check_session(get_session()), EMAIL)
    form = '<div class="error">' + '<br>'.join(errors) + '''</div>
        <form action="''' + CHANGE_USERINFO_CGI + get_session() + '''" method="post">
        <input type="hidden" name="'''+DESTINATION+'" value="'+EMAIL+'''">
        <table>
        <tr>
          <td colspan="2" class="title">Change Email</td>
        </tr>
        <tr>
          <td colspan="2">
            Your current email is ''' + current_email + '''.
          </td>
        </tr>
        <tr>
          <td align="right">New email:</td>
          <td><input type="text" name="'''+EMAIL+'" value="'+dict.get(EMAIL, '')+'''"></td>
        </tr>
        <tr>
          <td></td>
          <td><input type="submit" value="Change Email"></td>
        </tr>
        </table>'''
    for key in dict.keys():
        if key not in SAVED_KEYS:
            form += '<input type="hidden" name="' + key + \
                    '" value="' + dict[key] + '">\n'
    form += '</form>'
    return form

def print_forms(form_string):
    print get_header() + welcome_text + form_string + get_footer()

############### MAIN FUNCTIONS ##############

def login(dict):
    """Check the id and password against stored logins.
       If they are recognized, create a session and display the
         destination specified (under the base login).
       If they are not recognized, print the login form again.
    """
    user = dict.get(LOGIN, '')
    password = dict.get(PASSWD, '')
    if not (user or password):
        print_forms(login_form() + newuser_form() + forgot_form())
        return
    dest = dict.get(DESTINATION, DEFAULT_DEST)
    if get(user, PASSWD) == encrypt(user, password):
        session = make_session(user)
        if dest in SPECIAL_DESTINATIONS:
            form = '<p>Login was successful.<p><form method="post" action="'+dest+session+'">\n'
            del dict[LOGIN]
            del dict[PASSWD]
            del dict[DESTINATION]
            for key in dict.keys():
                form += '<input type="hidden" name="'+key+'" value="' + dict[key] + '">\n'
            form += '<input type="submit" value="Continue">\n</form>\n'
            print_forms(form)
        else:
            print forward(dest+session)
    else:
        print_forms(login_form(dict, ['Please enter your username and password again.']) + newuser_form() + forgot_form())

def add_user(dict):
    if not ALLOW_NEWUSERS:
        print_forms(login_form(dict, ["Sorry, new users aren't allowed on this system."]) + newuser_form() + forgot_form())
        return
    errors = []
    users = get_userdict()
    try:
        user = dict[LOGIN]
        if user in users:
            errors.append('That username is taken.  Please choose another.')
        errors.extend(_password_error(dict[PASSWD], dict[PASSWD2]))
    except:
        errors.append('Please enter your username and password again.')
    if errors:
        print_forms(newuser_form(dict, errors))
    else:
        del dict[PASSWD2]
        htpasswd_create(user, dict[PASSWD])
        for attribute in dict.keys():
            if attribute == PASSWD:
                set(user, attribute, encrypt(user, dict[attribute]))
            elif attribute not in UNSAVED_ATTS:
                set(user, attribute, dict[attribute])
        login(dict)

def remove_user(dict):
    # TODO not called from anywhere
    user = dict.get(LOGIN, '')
    result = []
    if not user:
        result.append('Enter a username.')
    else:
        users = get_userdict()
        if user in users:
            del users[user]
            save_userdict(users)
            result.append('Username ' + user + ' deleted.')
        else:
            result.append('Username not found.')
    print_forms(login_form({}, result) + newuser_form() + forgot_form())

def change(dict):
    user = check_session(get_session())
    results = []
    if not user:
        print_forms(login_form({}, ['Your session has timed out.  Please log in again.']))
    dest = dict.get(DESTINATION, '')
    if dest == EMAIL:
        new_email = dict.get(EMAIL, '')
        if not new_email:
            print_forms(change_email_form({}, ['Please enter your new email address again.']))
        else:
            users = get_userdict()
            if user in users:
                set(user, EMAIL, new_email)
                results.append('Email changed for username ' + user + '.')
            else:
                results.append('Username not found.')
            print get_header() + '<p>'.join(results) + '<p><a href="' + \
                  DEFAULT_DEST + get_session() + '">Back to index</a><p>' + get_footer()

def change_password(dict):
    user = check_session(get_session())
    new1 = dict.get(PASSWORD, '')
    new2 = dict.get(PASSWORD+'2', '')
    results = []
    if not user:
        print_forms(login_form({}, ['Your session has timed out.  Please log in again.']))
    errors = _password_error(new1, new2)
    if errors:
        print_forms(change_password_form({}, errors))
    else:
        users = get_userdict()
        if user in users:
            set(user, PASSWD, encrypt(user, new1))
            results.append('Password changed for username ' + user + '.')
        else:
            results.append('Username not found.')
        print get_header() + '<p>'.join(results) + '<p><a href="' + \
              DEFAULT_DEST + get_session() + '">Back to index</a><p>' + get_footer()
    

def reset_password(dict): 
    import emailer
    msg = []
    username = dict.get(LOGIN, '')
    if not get(username, LOGIN):
        print_forms(login_form() + newuser_form() + forgot_form(dict, ["That username isn't recognized.  Please try again."]))
    else:
        email = get(username, EMAIL)
        if not email:
            msg.append("There's no email address is on file for that username.  Password cannot be reset.")
        else:
            password = generate_password()
            set(username, PASSWD, encrypt(username, password))
            eml = "Subject: " + SURVEY_NAME + " information\r\n\r\n" + \
                  "Your new password for " + SURVEY_NAME + " is: \n\n" + \
                  password
            err = emailer.send(eml, emailer.no_reply_email, [email])
            if err:
                msg.append('<br>\n'.join(err))
            else:
                msg.append('An email has been sent to the email address on file for that username.')
        print_forms(login_form({}, msg) + newuser_form() + forgot_form())
