CONFIG_FILE         = 'config'

CRYPT               = 'crypt'
MD5                 = 'md5'

OPEN                = 'open' 
CLOSED              = 'closed'

EDIT_SURVEY         = 'edit'
PREVIEW_SURVEY_CGI  = 'preview.cgi' # no cgi script as of v. 1.2
SAVE_SURVEY_CGI     = 'save.cgi'    # no cgi script as of v. 1.2
VIEW_RESULTS_CGI    = 'results.cgi' # no cgi script as of v. 1.2
NEW_SURVEY          = 'new_survey'
LOCK_SURVEY         = 'lock_survey'
OPEN_CLOSE_SURVEY   = 'open_close_survey'
SET_OPEN_CLOSE      = 'set_open_close'
ENTER_PARTICIPANTS  = 'enter_participants'
DELETE_SURVEY       = 'delete_survey'
EDIT_OPTION_NAME    = 'edit_option'
TESTING             = 'testing'
OVERWRITE_SURVEY    = 'overwrite'   # repeats a tag found below

# fields used in the creation of surveys
INPUT_METHOD        = 'input_method'
TEXT_INPUT          = 'text'
WEB_INPUT           = 'web'
EDIT_TEXT           = 'edit'
OVERWRITE           = OVERWRITE_SURVEY
OLD_SURVEY_ID       = 'old_survey_id'

# survey attributes 
SURVEY_ID           = 'survey_id'
TITLE               = 'title'
QUESTIONS           = 'questions'
PAGES               = 'pages'
RAWDATA             = 'rawdata'
TIMESTAMP           = 'timestamp'

# These fields are saved in hidden fields between
# editing, previewing, and saving
SAVED_FIELDS        = [OVERWRITE, OLD_SURVEY_ID, TITLE]

# fields used in saved surveys
RAWTEXT             = 'rawtext'
PAGENUM             = 'pagenum'
USER_ID             = 'id'

# question types
V_RADIO             = 'vertical-radio'
H_RADIO             = 'horizontal-radio'
V_CHECKBOX          = 'vertical checkbox'
H_CHECKBOX          = 'horizontal checkbox'
SELECT              = 'select'
TEXTINPUT           = 'textinput'
TEXTAREA            = 'textarea'
PASSWORD            = 'password'
PAGEBREAK           = 'pagebreak'
PAGETITLE           = 'pagetitle'
TEXT                = 'text'
RESET               = 'reset'

# question categories
multiple_choice_qs  = [V_RADIO, V_CHECKBOX, \
                       H_RADIO, H_CHECKBOX, SELECT]
text_questions      = [TEXTINPUT, TEXTAREA, PASSWORD]

numbered_questions  = multiple_choice_qs[:]
numbered_questions.extend(text_questions)

# these tell us whether a survey is 'open' or 'closed'
OPENNESS            = 'openness'
OPEN_DATE           = 'opening_date'
CLOSE_DATE          = 'closing_date'
MONTH               = 'month'
DAY                 = 'day'
YEAR                = 'year'
HOUR                = 'hour'
MINUTE              = 'minute'
TD_OPEN_OPTION      = 'open_option' # must match format.css

# list of survey attributes for iteration in survey initialization
# (questions, pages, and rawdata added separately)
survey_atts         = [SURVEY_ID, TITLE]

# required question attributes
QTYPE               = 'type'
QCODE               = 'code' # not stored in input dict, just in question instances

# other question attributes
QNUMBER             = 'number' # not stored in input dict, just in question instances
QTEXT               = 'text' 
QREQUIRED           = 'required'
QCONDITION          = 'condition'
QOPTIONS            = 'option'
QLIKERT             = 'likert'
QOTHER              = 'other'
QWIDTH              = 'width'
QHEIGHT             = 'height'

# lists of question attributes for iteration (QCODE added separately)
q_atts_single       = [QTYPE, QTEXT, QREQUIRED, QCONDITION, QWIDTH, QHEIGHT]
q_atts_multi        = [QOPTIONS, QLIKERT]

# constants for results processing
FORMAT              = 'format'
CSV_TEXT            = 'csv_text'
CSV_NUM             = 'csv_num'
SPSS_DATA           = 'spss_data'
SPSS_VARS           = 'spss_vars'
HTML_FORMAT         = 'html'
INCLUDE             = 'include'
INCLUDE_ALL         = 'all'
INCLUDE_MULTI       = 'multi'
INCLUDE_TEXT        = 'text'
QUESTIONS_ONLY      = 'questions_only'

# used in authentication
SESSION_DIR         = 'sessions/'
USERS_DIR           = 'users/'
AUTHFILE            = USERS_DIR+'auth'
LOGIN               = 'login'
PASSWD              = 'passwd'
PASSWD2             = 'passwd2'
EMAIL               = 'email'
SURVEYS             = 'surveys'
HIDDEN              = 'hidden'
DESTINATION         = 'destination'

SAVED_KEYS          = [LOGIN, PASSWD, PASSWD2, EMAIL, HIDDEN]
# Don't save these in the user's information file
UNSAVED_ATTS        = [DESTINATION]    

CHANGE_PASSWORD     = 'change_password'
CHANGE_EMAIL        = 'change_email'
