from smtplib import SMTP
from config import MAILSERVER, DEFAULT_REPLY_EMAIL

reply_email = DEFAULT_REPLY_EMAIL
mailserver = MAILSERVER

#~~~~~~~~~~~~~~~~~~ EMAILERS ~~~~~~~~~~~~~~~~~~~#

def valid_email(eml):
  """Return 1 if eml has an '@', 0 otherwise.
  """
  if eml.find('@') < 0:
    return 0
  else:
    return 1


def send(msg, sender=reply_email, recipients=['ucbd-partners@uclink.berkeley.edu',]):
  """Send msg to specified recipients (default is ucbd-partners
     mailing list and sender), giving 'sender' as the sender.
     If 'sender' is not recognized by SMTP as valid, return a list
     of errors.  Else, return an empty list.
  """
  s = SMTP(mailserver)
  errors = []
  try:
    email = "From: " + sender + "\r\nTo: " + ', '.join(recipients) + \
            "\r\n" + msg + "\n\n\n\n"
    s.sendmail(sender, recipients, email)
  except:
    errors.append("Error - I can't send to the e-mail address '" + sender + "'!")
  s.close()
  return errors


def subscribe(email, action='subscribe', list='ucbd-partners', \
              listmanager='majordomo@uclink.berkeley.edu', \
              sender=reply_email):
  """Subscribe or unsubscribe (default is subscribe) to specified uclink
     mailing list (default is ucbd-partners) on behalf of the given
     email address.  Return a list of error messages if SMTP
     failed; else, return an empty list.
  """
  errors = []
  s = SMTP(mailserver)
  email = "From: " + email + "\r\nTo: " + listmanager + "\r\n" + \
          "Subject: \r\n\r\n " + ' '.join([action, list, email])
  try:
    s.sendmail(sender, listmanager, email)
  except:
    errors.append("Error %sing you!<br>" % action.rstrip('e'))
  s.close()
  return errors
