'''
'''

import survey, time, auth
from helpers import *

def form(survey_id, cgi, errors=[]):
    '''Return an HTML form to open or close a survey
       or to set opening and closing dates of a survey.
    '''
    temp_survey = survey.survey(survey_id=survey_id)
    openness = temp_survey.get_openness()
    selected_open = ''
    selected_closed = ''
    if openness == OPEN:
        selected_open = ' checked'
    elif openness == CLOSED:
        selected_closed = ' checked'
    open = int(temp_survey.get_modifiers().get(OPEN_DATE, time.time()))
    close = temp_survey.get_modifiers().get(CLOSE_DATE, 0)
    if not close:
        close = 0
    close = int(close)
    (openyear, openmonth, openday, openhour, openminute) = time.localtime(open)[:5]
    if close:
        (closeyear, closemonth, closeday, closehour, closeminute) = time.localtime(close)[:5]
    else:
        (closeyear, closemonth, closeday, closehour, closeminute) = time.localtime(time.time()+DEFAULT_OPEN_DAYS*24*60*60)[:5]
        #('','','','','')
    string = get_header() + '''
The survey "''' + temp_survey.get(TITLE).strip() + \
'" is currently ' + temp_survey.get_openness() + '''.
Change this directly or set opening and closing dates below.<p>
<table><tr><td valign="top" class="'''+TD_OPEN_OPTION+'''">
<b>Option 1 - Set openness directly:</b><p>
<form method="POST" action="''' + cgi + '''">
<input type="hidden" name="'''+EDIT_OPTION_NAME+'" value="'+SET_OPEN_CLOSE+'''">
<input type="hidden" name="'''+SURVEY_ID+'" value="'+survey_id+'''">
<input type="radio" name="'''+OPENNESS+'" value="'+OPEN+'"'+selected_open+'''> Open survey<br>
<input type="radio" name="'''+OPENNESS+'" value="'+CLOSED+'"'+selected_closed+'''> Close survey<br>
<input type="submit" value="Submit">
</form>
</td><td valign="top" class="'''+TD_OPEN_OPTION+'''">
<b>Option 2 - Set opening and closing dates:</b><p>
<form method="POST" action="''' + cgi + '''">
<input type="hidden" name="'''+EDIT_OPTION_NAME+'" value="'+SET_OPEN_CLOSE+'''">
<input type="hidden" name="'''+SURVEY_ID+'" value="'+survey_id+'''">
<div class="error">''' + '<br>'.join(errors) + '''</div>
<table>
<tr>
  <td colspan="2">Opening date:</td>
</tr>
<tr>
  <td colspan="2">
    <input type="text" size="2" name="''' + OPEN + MONTH + '" value="' + str(openmonth) + \
    '">/<input type="text" size="2" name="' + OPEN + DAY + '" value="' + str(openday) + \
    '">/<input type="text" size="4" name="' + OPEN + YEAR + '" value="' + str(openyear) + \
    '"> <input type="text" size="2" name="''' + OPEN + HOUR + '" value="' + str(openhour) + \
    '">:<input type="text" size="2" name="' + OPEN + MINUTE + '" value="' + str(openminute) + \
    '''">
  </td>
</tr>
<tr>
  <td colspan="2">Closing date:</td>
</tr>
<tr>
  <td colspan="2">
    <input type="text" size="2" name="''' + CLOSED + MONTH + '" value="' + str(closemonth) + \
    '">/<input type="text" size="2" name="' + CLOSED + DAY + '" value="' + str(closeday) + \
    '">/<input type="text" size="4" name="' + CLOSED + YEAR + '" value="' + str(closeyear) + \
    '"> <input type="text" size="2" name="''' + CLOSED + HOUR + '" value="' + str(closehour) + \
    '">:<input type="text" size="2" name="' + CLOSED + MINUTE + '" value="' + str(closeminute) + \
    '''">
  </td>
</tr>
</table>
<input type="submit" value="Submit">
</form>
</td>
</tr>
</table>
''' + get_footer()
    return string

def error_check(dict):
    errors = []
    # TODO
    return errors

def run(dict, u_id):
    errors = error_check(dict)
    if errors:
        return 0
    else:
        temp_survey = survey.survey(survey_id=dict[SURVEY_ID])
        openness = dict.get(OPENNESS)
        if openness:
            (y, mo, d, h, min) = time.localtime()[:5]
            if openness == OPEN:
                temp_survey.set_openness(y, mo, d, h, min, OPEN_DATE)
                temp_survey.set_openness(0, 0, 0, 0, 0, CLOSE_DATE)
            elif openness == CLOSED:
                temp_survey.set_openness(y, mo, d, h, min, CLOSE_DATE)
        else:
            openyear = int(dict.get(OPEN+YEAR))
            openmonth = int(dict.get(OPEN+MONTH))
            openday = int(dict.get(OPEN+DAY))
            openhour = int(dict.get(OPEN+HOUR))
            openminute = int(dict.get(OPEN+MINUTE))
            closeyear = int(dict.get(CLOSED+YEAR))
            closemonth = int(dict.get(CLOSED+MONTH))
            closeday = int(dict.get(CLOSED+DAY))
            closehour = int(dict.get(CLOSED+HOUR))
            closeminute = int(dict.get(CLOSED+MINUTE))
            temp_survey.set_openness(openyear, openmonth, openday, \
                                 openhour, openminute, OPEN_DATE)
            temp_survey.set_openness(closeyear, closemonth, closeday, \
                                 closehour, closeminute, CLOSE_DATE)
    return 1
